/*
 * ExactCompare.h
 *
 *  Created on: Oct 14, 2014
 *	  Author: Radomir Polach
 */

#ifndef EXACT_COMPARE_H_
#define EXACT_COMPARE_H_

#include <string/String.h>

namespace string {

namespace naive {

class ExactCompare : public string::VisitableStringBase::const_promoting_visitor_type {
public:
	static int compare(const string::String& u, const string::String& v);

	static int compare(const string::Epsilon& u, const string::Epsilon& v);
	static int compare(const string::LinearString& u, const string::LinearString& v);
	static int compare(const string::CyclicString& u, const string::CyclicString& v);

private:
	void Visit(void*, const Epsilon& u, const Epsilon& v) const;
	void Visit(void*, const LinearString& u, const LinearString& v) const;
	void Visit(void*, const CyclicString& u, const CyclicString& v) const;

	static const ExactCompare EXACT_COMPARE;
};

} /* namespace naive */

} /* namespace string */

#endif /* EXACT_COMPARE_H_ */
