/*
 * ExactMatch.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#ifndef _EXACT_MATCH_H__
#define _EXACT_MATCH_H__

#include <string/String.h>

namespace stringology {

namespace exact {

class ExactMatch : public string::VisitableStringBase::const_promoting_visitor_type {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static std::set<unsigned> match(const string::String& subject, const string::String& pattern);

	static std::set<unsigned> match(const string::LinearString& subject, const string::LinearString& pattern);
private:
	void Visit(void*, const string::Epsilon& subject, const string::Epsilon& pattern) const;
	void Visit(void*, const string::LinearString& subject, const string::LinearString& pattern) const;
	void Visit(void*, const string::CyclicString& subject, const string::CyclicString& pattern) const;

	static const ExactMatch EXACT_MATCH;
};

} /* namespace exact */

} /* namespace stringology */

#endif /* _EXACT_MATCH_H__ */
