/*
 * ExactSubsequenceAutomaton.h
 *
 *  Created on: 7. 4. 2015
 *      Author: Jan Travnicek
 */

#ifndef _EXACT_SUBSEQUENCE_AUTOMATON__H_
#define _EXACT_SUBSEQUENCE_AUTOMATON__H_

#include <automaton/Automaton.h>
#include <automaton/FSM/DFA.h>
#include <string/LinearString.h>
#include <string/String.h>

namespace stringology {

namespace exact {

class ExactSubsequenceAutomaton : public string::VisitableStringBase::const_visitor_type {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static automaton::Automaton construct(const string::String& text);

	static automaton::DFA construct(const string::LinearString& text);
private:
	void Visit(void*, const string::Epsilon& text) const;
	void Visit(void*, const string::LinearString& text) const;
	void Visit(void*, const string::CyclicString& text) const;

	static const ExactSubsequenceAutomaton EXACT_SUBSEQUENCE_AUTOMATON;
};

} /* namespace exact */

} /* namespace stringology */

#endif /* _EXACT_SUBSEQUENCE_AUTOMATON__H_ */
