/*
 * NextSymbol.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef NEXT_SYMBOL_H_
#define NEXT_SYMBOL_H_

#include <list>
#include "Symbol.h"
#include "../sax/Token.h"

namespace alphabet {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class NextSymbol : public VisitableSymbolBase::visitor_type {
	void Visit(void*, const LabeledSymbol& symbol);
	void Visit(void*, const BlankSymbol& symbol);
	void Visit(void*, const BottomOfTheStackSymbol& symbol);
	void Visit(void*, const EndSymbol& symbol);
	void Visit(void*, const StartSymbol& symbol);
	void Visit(void*, const RankedSymbol& symbol);
	void Visit(void*, const BarSymbol& symbol);
	void Visit(void*, const RankedBarSymbol& symbol);
	void Visit(void*, const SubtreeWildcardSymbol& symbol);
	void Visit(void*, const SymbolPairSymbol& symbol);
	void Visit(void*, const SymbolSetSymbol& symbol);
	void Visit(void*, const UniqueSymbol& symbol);

public:
	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	Symbol nextSymbol(const Symbol& label);
};

} /* namespace alphabet */

#endif /* NEXT_SYMBOL_H_ */
