/*
 * RankedBarSymbol.cpp
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "RankedBarSymbol.h"

namespace alphabet {

RankedBarSymbol::RankedBarSymbol(int rank) : rank(primitive::Integer(rank)) {

}

RankedBarSymbol::RankedBarSymbol(const primitive::Integer& rank) : rank(rank) {

}

SymbolBase* RankedBarSymbol::clone() const {
	return new RankedBarSymbol(*this);
}

SymbolBase* RankedBarSymbol::plunder() && {
	return new RankedBarSymbol(std::move(*this));
}

const primitive::Integer& RankedBarSymbol::getRank() const {
	return rank;
}

int RankedBarSymbol::compare(const RankedBarSymbol&) const {
	return 0;
}

void RankedBarSymbol::operator>>(std::ostream& out) const {
	out << "(RankedBar symbol)";
}

RankedBarSymbol::operator std::string () const {
	return "|";
}

} /* namespace alphabet */
