/*
 * Automaton.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef AUTOMATON_H_
#define AUTOMATON_H_

#include "../std/visitor.hpp"
#include "../std/compare.hpp"
#include "AutomatonBase.h"
#include "../common/wrapper.hpp"

#include "common/State.h"
#include <set>
#include <string>

namespace automaton {

/**
 * Wrapper around automata.
 */
typedef alib::wrapper<AutomatonBase> Automaton;

State createUniqueState(const State& base, const std::set<State>& other);

} /* namespace automaton */

namespace std {

template<>
struct compare<automaton::Automaton> {
	int operator()(const automaton::Automaton& first, const automaton::Automaton& second) const {
		return first.getData().compare(second.getData());
	}
};

} /* namespace std */

#endif /* AUTOMATON_H_ */

