/*
 * Container.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef CONTAINER_H_
#define CONTAINER_H_

#include "../std/visitor.hpp"
#include "../std/compare.hpp"
#include "ContainerBase.h"
#include "../common/wrapper.hpp"

namespace container {

/**
 * Wrapper around containers.
 */
typedef alib::wrapper<ContainerBase> Container;

} /* namespace container */

namespace std {

template<>
struct compare<container::Container> {
	int operator()(const container::Container& first, const container::Container& second) const {
		return first.getData().compare(second.getData());
	}
};

} /* namespace std */

#endif /* CONTAINER_H_ */

