/*
 * GrammarFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef GRAMMAR_FROM_STRING_LEXER_H_
#define GRAMMAR_FROM_STRING_LEXER_H_

#include <string>
#include <sstream>

namespace grammar {

class GrammarFromStringLexer {
public:
	enum class TokenType {
		SET_BEGIN,
		SET_END,
		COMMA,
		TUPLE_BEGIN,
		TUPLE_END,
		SEPARATOR,
		EPSILON,
		MAPS_TO,
		RIGHT_RG,
		LEFT_RG,
		RIGHT_LG,
		LEFT_LG,
		LG,
		CFG,
		EPSILON_FREE_CFG,
		GNF,
		CNF,
		CSG,
		NON_CONTRACTING_GRAMMAR,
		CONTEXT_PRESERVING_UNRESTRICTED_GRAMMAR,
		UNRESTRICTED_GRAMMAR,
		TEOF,
		ERROR,
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	Token next(std::istream& input) const;
	void putback(std::istream&, Token token) const;
};

} /* namepsace grammar */

#endif /* GRAMMAR_FROM_STRING_LEXER_H_ */
