#ifndef GRAPH_BASE_H_
#define GRAPH_BASE_H_

#include "common/Macros.h"
#include "../common/base.hpp"
#include "../object/ObjectBase.h"

namespace graph {

class GraphBase;

typedef std::acceptor_base<GraphBase, DirectedGraph, UndirectedGraph> VisitableGraphBase;

// Abstract base class for all graphs.
class GraphBase : public alib::ObjectBase, public VisitableGraphBase
{
public:
	using VisitableGraphBase::Accept;
	using alib::VisitableObjectBase::Accept;

	virtual GraphBase *clone() const = 0;
	virtual GraphBase *plunder() && = 0;
};

} // namespace graph

GRAPH_DEFINE_STD_COMPARE(GraphBase)

#endif // GRAPH_BASE_H_
