#ifndef GRAPH_ELEMENT_H_
#define GRAPH_ELEMENT_H_

// for std::hash
#include <string>
#include <functional>

#include "../../std/visitor.hpp"
#include "../../object/Object.h"

namespace graph {

class GraphElement;

class Node;
class DirectedEdge;
class UndirectedEdge;

// Abstract class representing element in the graph. Can be node or edge.
typedef std::acceptor_base<GraphElement, Node, DirectedEdge, UndirectedEdge> VisitableGraphElement;

class GraphElement : public alib::base<GraphElement, Node, DirectedEdge, UndirectedEdge>, public VisitableGraphElement
{
public:
	explicit GraphElement();
};

} // namespace graph

#endif // GRAPH_ELEMENT_H_
