#ifndef GRAPH_UTILS_H_
#define GRAPH_UTILS_H_

#include <algorithm>

#include "../common/Node.h"
#include "UndirectedEdge.h"

namespace graph {

static bool edgeMatch(const UndirectedEdge &edge, const Node &first, const Node &second)
{
	if (edge.getFirstNode() == first && edge.getSecondNode() == second) {
		return true;
	}
	if (edge.getFirstNode() == second && edge.getSecondNode() == first) {
		return true;
	}
	return false;
}

static bool edgeMatch(const UndirectedEdge &edge, const Node &node, const std::set<Node> &neighbors)
{
	if (edge.getFirstNode() == node && neighbors.find(edge.getSecondNode()) != neighbors.end()) {
		return true;
	}
	if (edge.getSecondNode() == node && neighbors.find(edge.getFirstNode()) != neighbors.end()) {
		return true;
	}
	return false;
}

template<typename T>
inline void listRemoveOne(std::list<T> &lst, const T &item)
{
	lst.erase(std::find(lst.begin(), lst.end(), item));
}

} // namespace graph

#endif // GRAPH_UTILS_H_
