/*
 * Label.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef LABEL_H_
#define LABEL_H_

#include "../std/visitor.hpp"
#include "../std/compare.hpp"
#include "../common/wrapper.hpp"
#include "LabelBase.h"

namespace label {

/**
 * Wrapper around automata.
 */
typedef alib::wrapper<LabelBase> Label;

label::Label labelFrom(int number);
label::Label labelFrom(int number1, int number2);
label::Label labelFrom(char character);
label::Label labelFrom(const std::string& string);
label::Label labelFrom(const char* string);

} /* namespace label */

namespace std {

template<>
struct compare<label::Label> {
	int operator()(const label::Label& first, const label::Label& second) const {
		return first.getData().compare(second.getData());
	}
};

} /* namespace std */

#endif /* LABEL_H_ */

