/*
 * LabelBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef LABEL_BASE_H_
#define LABEL_BASE_H_

#include "../common/base.hpp"
#include "../object/ObjectBase.h"

namespace label {

class LabelBase;

typedef std::acceptor_base<LabelBase,
			label::PrimitiveLabel, label::HexavigesimalLabel, label::ObjectLabel, label::LabelSetLabel, label::LabelPairLabel, label::UniqueLabel
	> VisitableLabelBase;

/**
 * Abstract base class for all automata.
 */
class LabelBase : public alib::ObjectBase, public VisitableLabelBase {
public:
	using VisitableLabelBase::Accept;
	using alib::VisitableObjectBase::Accept;

	virtual LabelBase* clone() const = 0;
	virtual LabelBase* plunder() && = 0;

};

} /* namespace label */

namespace std {

template<>
struct compare<label::LabelBase> {
	int operator()(const label::LabelBase& first, const label::LabelBase& second) const {
		return first.compare(second);
	}
};

} /* namespace std */

#endif /* LABEL_BASE_H_ */

