/*
 * Bool.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "Bool.h"

namespace primitive {

Bool::Bool(bool data) : data(data) {

}

PrimitiveBase* Bool::clone() const {
	return new Bool(*this);
}

PrimitiveBase* Bool::plunder() && {
	return new Bool(std::move(*this));
}

bool Bool::getData() const {
	return data;
}

int Bool::compare(const Bool& other) const {
	return data - other.data;
}

void Bool::operator>>(std::ostream& out) const {
	out << "(Bool " << (data ? "true" : "false") << ")";
}

Bool::operator std::string() const {
	return data ? "true" : "false";
}

} /* namespace primitive */

