/*
 * Primitive.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef PRIMITIVE_H_
#define PRIMITIVE_H_

#include "../std/visitor.hpp"
#include "../std/compare.hpp"
#include "../common/wrapper.hpp"
#include "PrimitiveBase.h"

namespace primitive {

/**
 * Wrapper around primitive data types.
 */
typedef alib::wrapper<PrimitiveBase> Primitive;

Primitive primitiveFrom(int number);
Primitive primitiveFrom(char character);
Primitive primitiveFrom(const std::string& string);
Primitive primitiveFrom(const char* string);
Primitive primitiveFrom(unsigned number);
Primitive primitiveFrom(bool value);

} /* namespace primitive */

namespace std {

template<>
struct compare<primitive::Primitive> {
	int operator()(const primitive::Primitive& first, const primitive::Primitive& second) const {
		return first.getData().compare(second.getData());
	}
};

} /* namespace std */

#endif /* PRIMITIVE_H_ */

