/*
 * PrimitiveToStringComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef PRIMITIVE_TO_STRING_COMPOSER_H_
#define PRIMITIVE_TO_STRING_COMPOSER_H_

#include <ostream>
#include "Primitive.h"

namespace primitive {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class PrimitiveToStringComposer : public VisitablePrimitiveBase::const_visitor_type {
	void Visit(void*, const Integer& primitive) const;
	void Visit(void*, const String& primitive) const;
	void Visit(void*, const Character& primitive) const;
	void Visit(void*, const Unsigned& primitive) const;
	void Visit(void*, const Bool& primitive) const;
public:
	/**
	 * Prints text representation of Primitive to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	void compose(std::ostream& out, const Primitive& string) const;
};

} /* namespace primitive */

#endif /* PRIMITIVE_TO_STRING_COMPOSER_H_ */
