/*
 * RegExpBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef REG_EXP_BASE_H_
#define REG_EXP_BASE_H_

#include "../common/base.hpp"
#include "../object/ObjectBase.h"

namespace regexp {

class RegExpBase;

typedef std::acceptor_base<RegExpBase,
			UnboundedRegExp, FormalRegExp
	> VisitableRegExpBase;

/**
 * Abstract base class for all automata.
 */
class RegExpBase : public alib::ObjectBase, public VisitableRegExpBase {
public:
	using VisitableRegExpBase::Accept;
	using alib::VisitableObjectBase::Accept;

	virtual RegExpBase* clone() const = 0;
	virtual RegExpBase* plunder() && = 0;
};

} /* namespace regexp */

namespace std {

template<>
struct compare<regexp::RegExpBase> {
	int operator()(const regexp::RegExpBase& first, const regexp::RegExpBase& second) const {
		return first.compare(second);
	}
};

} /* namespace std */

#endif /* REG_EXP_BASE_H_ */

