/*
 * RegExpFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef REG_EXP_FROM_STRING_PARSER_H_
#define REG_EXP_FROM_STRING_PARSER_H_

#include "RegExp.h"
#include "unbounded/UnboundedRegExpElements.h"
#include "formal/FormalRegExpElements.h"

#include "RegExpFromStringLexer.h"
#include "RegExpFeatures.h"

namespace alib {

template<typename T>
struct stringApi;

} /* namespace alib */

namespace regexp {

class RegExpFromStringParser {
	UnboundedRegExpElement* alternation(std::istream& input) const;
	UnboundedRegExpElement* alternationCont(std::istream& input, UnboundedRegExpElement* left) const;
	UnboundedRegExpElement* alternationContCont(std::istream& input, UnboundedRegExpAlternation* left) const;

	UnboundedRegExpElement* concatenation(std::istream& input) const;
	UnboundedRegExpElement* concatenationCont(std::istream& input, UnboundedRegExpElement* left) const;
	UnboundedRegExpElement* concatenationContCont(std::istream& input, UnboundedRegExpConcatenation* left) const;

	UnboundedRegExpElement* factor(std::istream& input) const;
	UnboundedRegExpElement* star(std::istream& input, UnboundedRegExpElement* elem) const;

	RegExpFromStringLexer m_RegexpLexer;

	RegExp parseRegExp(std::istream& input) const;
	RegExp parseRegExp(std::istream& input, const std::set<FEATURES>& features) const;

	template<typename T> friend class alib::stringApi;
};

} /* namespace regexp */

#endif /* REG_EXP_FROM_STRING_PARSER_H_ */
