/*
 * FromXMLParserHelper.cpp
 *
 *  Created on: Oct 12, 2013
 *      Author: Jan Travnicek
 */

#include "FromXMLParserHelper.h"
#include "ParserException.h"

namespace sax {

bool FromXMLParserHelper::isToken(const std::list<Token>& input, Token::TokenType type, std::string data) {
	return input.front().getType() == type && input.front().getData() == data;
}

bool FromXMLParserHelper::isTokenType(const std::list<Token>& input, Token::TokenType type) {
	return input.front().getType() == type;
}

void FromXMLParserHelper::popToken(std::list<Token>& input, Token::TokenType type, std::string data) {
	if (isToken(input, type, data)) {
		input.pop_front();
	} else {
		throw ParserException(Token(data, type), input.front());
	}
}

std::string FromXMLParserHelper::popTokenData(std::list<Token>& input, Token::TokenType type) {
	if(isTokenType(input, type)) {
		std::string result = input.front().getData();
		input.pop_front();
		return std::move(result);
	} else {
		throw ParserException(Token("?", type), input.front());
	}
}

} /* namespace sax */
