#include <list>
#include "PrimitiveTest.h"

#include "sax/SaxParseInterface.h"
#include "sax/SaxComposeInterface.h"

#include "primitive/Primitive.h"

#include "factory/XmlDataFactory.hpp"
#include "factory/StringDataFactory.hpp"
#include <algorithm>

#define CPPUNIT_EXCLUSIVE_OR(x, y) CPPUNIT_ASSERT((!(x) && (y)) || ((x) && !(y)))

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( PrimitiveTest, "primitive" );
CPPUNIT_TEST_SUITE_REGISTRATION( PrimitiveTest );

void PrimitiveTest::setUp() {
}

void PrimitiveTest::tearDown() {
}

void PrimitiveTest::testXMLParser() {

	primitive::Primitive primitive = primitive::primitiveFrom("aaa");
	std::cout << primitive << std::endl;

	{
		std::list<sax::Token> tokens = alib::XmlDataFactory::toTokens(primitive);
		std::cout << tokens << std::endl;
		std::string tmp;
		sax::SaxComposeInterface::printMemory(tmp, tokens);

		std::list<sax::Token> tokens2;
		sax::SaxParseInterface::parseMemory(tmp, tokens2);
		primitive::Primitive primitive2 = alib::XmlDataFactory::fromTokens<primitive::Primitive>(tokens2);

		CPPUNIT_ASSERT( primitive == primitive2 );
	}
	{
		std::string tmp = alib::XmlDataFactory::toString(primitive);
		primitive::Primitive primitive2 = alib::XmlDataFactory::fromString<primitive::Primitive>(tmp);

		CPPUNIT_ASSERT( primitive == primitive2 );
	}
}

