#include "SaxTest.h"
#include <string>
#include <iostream>

#include "sax/SaxParseInterface.h"
#include "sax/SaxComposeInterface.h"

#define CPPUNIT_EXCLUSIVE_OR(x, y) CPPUNIT_ASSERT((!(x) && (y)) || ((x) && !(y)))

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( SaxTest, "sax" );
CPPUNIT_TEST_SUITE_REGISTRATION( SaxTest );

void SaxTest::setUp() {
}

void SaxTest::tearDown() {
}

void SaxTest::testSax() {
	std::string tmp = "<?xml version=\"1.0\"?>\n<aa bb=\"cc\"><xx/>dd</aa>\n";
	
	std::list<sax::Token> tokens;
	sax::SaxParseInterface::parseMemory(tmp, tokens);

	std::string tmp2;
	sax::SaxComposeInterface::printMemory(tmp2, tokens);

	CPPUNIT_ASSERT( tmp == tmp2 );

	std::list<sax::Token> tokens2;
	sax::SaxParseInterface::parseMemory(tmp2, tokens2);

	CPPUNIT_ASSERT( tokens == tokens2 );
}
