/*
 * SetStat.cpp
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#include "SetStat.h"

#include <exception/AlibException.h>

#include <factory/XmlDataFactory.hpp>

void SetStat::stat(const container::ObjectsSet& data, const SetSettings& settings) {
	switch(settings.general) {
	case PrintingOptions::PRINT:
		alib::XmlDataFactory::toStdout(data);
		break;
	case PrintingOptions::QUANTITY:
		std::cout << data.size() << std::endl;
		break;
	case PrintingOptions::BOTH:
		std::cout << data.size() << std::endl;
		alib::XmlDataFactory::toStdout(data);
		break;
	case PrintingOptions::NOOP:
		break;
	}
}
